<template>
  <v-container
    style="height: 100%"
    fluid
  >
    <base-searchbar
      :filter-by="filterList"
      :filter-count="1"
      title="Archive"
      icon="mdi-book-open-page-variant"
      show-add-filter
      :hide-status="isStudent"
      @trigger="$trigger"
      @refresh="bootstrap"
    >
      <template #body>
        <v-btn
          v-if="!isStudent"
          color="primary"
          @click="modals.createArchive.status = true"
        >
          <!-- @click="$router.push({ name: 'ArchiveCreate' })" -->
          <v-icon>mdi-plus</v-icon>
        </v-btn>
      </template>
    </base-searchbar>

    <v-card>
      <v-data-table
        :headers="headers"
        :items="archivesList"
        class="elevation-1"
        :loading="dataStatus.archiveTable.loading"
      >
        <template #[`item.title`]="{ item }">
          <div
            class="font-weight-bold"
            style="cursor: pointer"
            @click="$router.push({ name: 'ArchiveDetail', params: { id: item.id } })"
          >
            {{ item.title | $truncateString(100) }}
          </div>
        </template>

        <template #[`item.note`]="{ item }">
          {{ item.note | $truncateString(200) }}
        </template>

        <template #[`item.tags`]="{ item }">
          <v-chip
            v-for="(currItem, itemKey) in item.tags"
            :key="itemKey"
            class="ma-1 light-blue lighten-5"
            label
            small
            v-text="currItem"
          />
        </template>

        <template #[`item.published_date`]="{ item }">
          {{ item.published_date | $humanDate }}
        </template>

        <template #[`item.authors`]="{ item }">
          <v-chip
            v-for="(currItem, itemKey) in item.authors"
            :key="itemKey"
            class="ma-1 green lighten-5"
            label
            small
          >
            {{ currItem.name }} | {{ currItem.year }}-{{ currItem.section }}
          </v-chip>
        </template>

        <template #[`item.actions`]="{ item }">
          <v-menu
            bottom
            left
          >
            <template #activator="{ on, attrs }">
              <v-btn
                icon
                v-bind="attrs"
                small
                v-on="on"
              >
                <v-icon>mdi-dots-vertical</v-icon>
              </v-btn>
            </template>

            <v-list dense>
              <v-list-item-group>
                <v-list-item
                  v-if="!isStudent"
                  @click="handleClickModifyArchive({ item })"
                >
                  <v-list-item-icon>
                    <v-icon small>
                      mdi-pencil
                    </v-icon>
                  </v-list-item-icon>

                  <v-list-item-content>
                    <v-list-item-title>Edit</v-list-item-title>
                  </v-list-item-content>
                </v-list-item>

                <v-list-item
                  v-if="!item.deleted_at && !isStudent"
                  @click="handleClickDeleteArchive({ item })"
                >
                  <v-list-item-icon>
                    <v-icon small>
                      mdi-delete
                    </v-icon>
                  </v-list-item-icon>

                  <v-list-item-content>
                    <v-list-item-title>Delete</v-list-item-title>
                  </v-list-item-content>
                </v-list-item>

                <v-list-item
                  v-if="item.deleted_at && !isStudent"
                  @click="handleClickRestoreArchive({ item })"
                >
                  <v-list-item-icon>
                    <v-icon small>
                      mdi-restore
                    </v-icon>
                  </v-list-item-icon>

                  <v-list-item-content>
                    <v-list-item-title>Restore</v-list-item-title>
                  </v-list-item-content>
                </v-list-item>

                <v-list-item @click="handleClickDownloadFile({ item, key: 'note' })">
                  <v-list-item-icon>
                    <v-icon small>
                      mdi-download
                    </v-icon>
                  </v-list-item-icon>

                  <v-list-item-content>
                    <v-list-item-title>Download Abstract</v-list-item-title>
                  </v-list-item-content>
                </v-list-item>

                <v-list-item @click="handleClickDownloadFile({ item, key: 'path' })">
                  <v-list-item-icon>
                    <v-icon small>
                      mdi-download
                    </v-icon>
                  </v-list-item-icon>

                  <v-list-item-content>
                    <v-list-item-title>Download File</v-list-item-title>
                  </v-list-item-content>
                </v-list-item>
              </v-list-item-group>
            </v-list>
          </v-menu>
        </template>
      </v-data-table>
    </v-card>

    <!-- create archive -->
    <base-modal
      v-model="modals.createArchive.status"
      title="create archive"
      @trigger="handleTriggerCreateArchive"
    >
      <template #body>
        <h4 class="mb-3">
          Archive Details
        </h4>

        <v-row>
          <v-col cols="12">
            <v-text-field
              v-model="modals.createArchive.data.title"
              label="Title*"
              outlined
              dense
              required
              hide-details
            />
          </v-col>

          <v-col cols="12">
            <v-menu
              v-model="modals.createArchive.datePickerStatus"
              :close-on-content-click="false"
              max-width="290"
            >
              <template #activator="{ on, attrs }">
                <v-text-field
                  :value="computedDateFormattedMomentjs"
                  clearable
                  label="Published Date"
                  readonly
                  dense
                  v-bind="attrs"
                  outlined
                  hide-details
                  v-on="on"
                  @click:clear="modals.createArchive.data.published_date = null"
                />
              </template>

              <v-date-picker
                v-model="modals.createArchive.data.published_date"
                dense
                @change="modals.createArchive.datePickerStatus = false"
              />
            </v-menu>
          </v-col>

          <v-col cols="12">
            <v-text-field
              v-model="modals.createArchive.data.adviser"
              label="Adviser*"
              placeholder="Adviser*"
              outlined
              required
              dense
              hide-details
            />
          </v-col>

          <v-col cols="12">
            <v-file-input
              v-model="modals.createArchive.data.note"
              show-size
              counter
              dense
              hide-details
              outlined
              label="Abstract*"
            />
          </v-col>

          <v-col cols="12">
            <v-file-input
              v-model="modals.createArchive.data.file"
              show-size
              counter
              dense
              hide-details
              outlined
              label="File*"
            />
          </v-col>

          <v-col cols="12">
            <v-text-field
              label="Panelists*"
              placeholder="Press `enter` to add panelist"
              outlined
              required
              dense
              class="mb-2"
              hide-details
              @keyup.enter="handleClickCreatePanelistsKeyup({ modal: 'createArchive', e: $event })"
            />

            <v-chip
              v-for="(currItem, itemKey) in modals.createArchive.data.panelists"
              :key="itemKey"
              class="my-1 mr-1"
              close
              @click:close="handleClickCreateRemovePanelist({ key: itemKey, modal: 'createArchive' })"
            >
              {{ currItem.name }} | {{ currItem.year }}-{{ currItem.section }}
            </v-chip>
          </v-col>
        </v-row>

        <v-divider class="my-5" />

        <h4 class="mb-3">
          Keyword Details
        </h4>

        <v-row>
          <v-col cols="12">
            <v-text-field
              label="Keyword*"
              placeholder="Press `enter` to add keyword"
              outlined
              required
              dense
              hide-details
              @keyup.enter="handleEnterTag({ modal: 'createArchive', e:$event })"
            />

            <v-chip
              v-for="(currItem, itemKey) in modals.createArchive.data.tags"
              :key="itemKey"
              class="my-1 mr-1"
              close
              @click:close="modals.createArchive.data.tags.splice(itemKey, 1)"
            >
              {{ currItem }}
            </v-chip>
          </v-col>
        </v-row>

        <v-divider class="my-5" />

        <h4 class="mb-3">
          Author Details
        </h4>

        <v-row>
          <v-col cols="12">
            <v-text-field
              v-model="modals.createArchive.data.author.name"
              label="Author*"
              placeholder="Author*"
              outlined
              required
              dense
              hide-details
            />
          </v-col>

          <v-col cols="6">
            <v-text-field
              v-model="modals.createArchive.data.author.year"
              label="Year*"
              placeholder="Year*"
              outlined
              required
              dense
              hide-details
            />
          </v-col>

          <v-col cols="6">
            <v-text-field
              v-model="modals.createArchive.data.author.section"
              label="Section*"
              placeholder="Section*"
              outlined
              required
              dense
              hide-details
            />
          </v-col>

          <v-col cols="12">
            <v-chip
              v-for="(currItem, itemKey) in modals.createArchive.data.authors"
              :key="itemKey"
              class="my-1 mr-1"
              close
              @click:close="modals.createArchive.data.authors.splice(itemKey, 1)"
            >
              {{ currItem.name }} | {{ currItem.year }}-{{ currItem.section }}
            </v-chip>
          </v-col>

          <v-col
            cols="12"
            class="d-flex justify-end"
          >
            <v-btn
              small
              color="primary"
              @click="handleClickCreateAddAuthor({ modal: 'createArchive' })"
            >
              Add Author
            </v-btn>
          </v-col>
        </v-row>
      </template>
    </base-modal>

    <!-- modify archive -->
    <base-modal
      v-model="modals.modifyArchive.status"
      title="modify archive"
      @trigger="handleTriggerModifyArchive"
    >
      <template #body>
        <h4 class="mb-3">
          Archive Details
        </h4>

        <v-row>
          <v-col cols="12">
            <v-text-field
              v-model="modals.modifyArchive.data.title"
              label="Title*"
              outlined
              dense
              required
              hide-details
            />
          </v-col>

          <v-col cols="12">
            <v-menu
              v-model="modals.modifyArchive.datePickerStatus"
              :close-on-content-click="false"
              max-width="290"
            >
              <template #activator="{ on, attrs }">
                <v-text-field
                  :value="computedDateFormattedMomentjs"
                  clearable
                  label="Published Date"
                  readonly
                  dense
                  v-bind="attrs"
                  outlined
                  hide-details
                  v-on="on"
                  @click:clear="modals.modifyArchive.data.published_date = null"
                />
              </template>

              <v-date-picker
                v-model="modals.modifyArchive.data.published_date"
                dense
                @change="modals.modifyArchive.datePickerStatus = false"
              />
            </v-menu>
          </v-col>

          <v-col cols="12">
            <v-text-field
              v-model="modals.modifyArchive.data.adviser"
              label="Adviser*"
              placeholder="Adviser*"
              outlined
              required
              dense
              hide-details
            />
          </v-col>

          <v-col cols="12">
            <v-file-input
              v-model="modals.modifyArchive.data.note"
              show-size
              counter
              dense
              hide-details
              outlined
              label="Abstract*"
            />
          </v-col>

          <v-col cols="12">
            <v-file-input
              v-model="modals.modifyArchive.data.file"
              show-size
              counter
              dense
              hide-details
              outlined
              label="File*"
            />
          </v-col>

          <v-col cols="12">
            <v-text-field
              label="Panelists*"
              placeholder="Press `enter` to add panelist"
              outlined
              required
              dense
              class="mb-2"
              hide-details
              @keyup.enter="handleClickCreatePanelistsKeyup({ modal: 'modifyArchive', e: $event })"
            />

            <v-chip
              v-for="(currItem, itemKey) in modals.modifyArchive.data.panelists"
              :key="itemKey"
              class="my-1 mr-1"
              close
              @click:close="handleClickCreateRemovePanelist({ key: itemKey, modal: 'modifyArchive' })"
            >
              {{ currItem.name }} | {{ currItem.year }}-{{ currItem.section }}
            </v-chip>
          </v-col>
        </v-row>

        <v-divider class="my-5" />

        <h4 class="mb-3">
          Keyword Details
        </h4>

        <v-row>
          <v-col cols="12">
            <v-text-field
              label="Keyword*"
              placeholder="Press `enter` to add keyword"
              outlined
              required
              dense
              hide-details
              @keyup.enter="handleEnterTag({ modal: 'modifyArchive', e: $event })"
            />

            <v-chip
              v-for="(currItem, itemKey) in modals.modifyArchive.data.tags"
              :key="itemKey"
              class="my-1 mr-1"
              close
              @click:close="modals.modifyArchive.data.tags.splice(itemKey, 1)"
            >
              {{ currItem }}
            </v-chip>
          </v-col>
        </v-row>

        <v-divider class="my-5" />

        <h4 class="mb-3">
          Author Details
        </h4>

        <v-row>
          <v-col cols="12">
            <v-text-field
              v-model="modals.modifyArchive.data.author.name"
              label="Author*"
              placeholder="Author*"
              outlined
              required
              dense
              hide-details
            />
          </v-col>

          <v-col cols="6">
            <v-text-field
              v-model="modals.modifyArchive.data.author.year"
              label="Year*"
              placeholder="Year*"
              outlined
              required
              dense
              hide-details
            />
          </v-col>

          <v-col cols="6">
            <v-text-field
              v-model="modals.modifyArchive.data.author.section"
              label="Section*"
              placeholder="Section*"
              outlined
              required
              dense
              hide-details
            />
          </v-col>

          <v-col cols="12">
            <v-chip
              v-for="(currItem, itemKey) in modals.modifyArchive.data.authors"
              :key="itemKey"
              class="my-1 mr-1"
              close
              @click:close="modals.modifyArchive.data.authors.splice(itemKey, 1)"
            >
              {{ currItem.name }} | {{ currItem.year }}-{{ currItem.section }}
            </v-chip>
          </v-col>

          <v-col
            cols="12"
            class="d-flex justify-end"
          >
            <v-btn
              small
              color="primary"
              @click="handleClickCreateAddAuthor({ modal: 'modifyArchive' })"
            >
              Add Author
            </v-btn>
          </v-col>
        </v-row>
      </template>
    </base-modal>
  </v-container>
</template>

<script>
// eslint-disable-next-line no-unused-vars
import { mapActions, mapGetters, mapState } from 'vuex'

import moment from 'moment'
import _get from 'lodash/get'

export default {
  name: 'AdminArchive',

  data: () => ({
    filterList: ['Author', 'Keywords', 'Title'],
    dataStatus: {
      archiveTable: {
        loading: true
      }
    },
    headers: [
      {
        text: 'Title',
        align: 'start',
        value: 'title',
        width: 300
      },
      { text: 'Keywords', value: 'tags' },
      { text: 'Adviser', value: 'adviser' },
      { text: 'Panelists', value: 'panelists' },
      { text: 'Authors', value: 'authors' },
      { text: 'Published Date', value: 'published_date', width: 200 },
      { text: '', value: 'actions', width: 50 }
    ],

    modals: {
      createArchive: {
        status: 0,
        datePickerStatus: false,
        data: {
          title: '',
          note: null,
          published_date: moment().format('YYYY-MM-DD HH:mm:ss'),
          tags: [],
          authors: [],
          panelists: [],
          adviser: '',
          author: {},
          file: null
        },
        reset () {
          this.status = 0
          this.data = {
            title: '',
            published_date: moment().format('YYYY-MM-DD HH:mm:ss'),
            adviser: '',
            note: null,
            file: null,
            panelists: [],
            tags: [],
            authors: [],
            author: {}
          }
        }
      },
      modifyArchive: {
        status: false,
        datePickerStatus: false,
        data: {
          id: '',
          title: '',
          note: null,
          published_date: moment().format('YYYY-MM-DD HH:mm:ss'),
          tags: [],
          authors: [],
          panelists: [],
          adviser: '',
          author: {},
          file: null
        },
        reset () {
          this.status = 0
          this.data = {
            id: '',
            title: '',
            note: null,
            published_date: moment().format('YYYY-MM-DD HH:mm:ss'),
            tags: [],
            authors: [],
            panelists: [],
            adviser: '',
            author: {},
            file: null
          }
        }
      }
    }
  }),

  computed: {
    ...mapState('users', {
      authUser: 'authUser'
    }),

    ...mapState('archives', {
      archivesList: 'archives'
    }),

    ...mapState('tags', {
      tagsList: 'tags'
    }),

    computedDateFormattedMomentjs () {
      const date = this.modals.createArchive.data.published_date
      return date ? moment(date).format('dddd, MMMM Do YYYY') : ''
    },

    isStudent () {
      return this.authUser.level === 'student'
    }
  },

  watch: {
    $route: {
      async handler (data) {
        await this.bootstrap({ ...data.query })
      },

      immediate: true
    }
  },

  async created () {
    await this.getTagsList({ ...this.$route.query })
  },

  methods: {
    ...mapActions('archives', {
      postArchive: 'postArchive',
      updateArchive: 'updateArchive',
      getArchivesList: 'getArchivesList',
      deleteArchive: 'deleteArchive',
      restoreArchive: 'restoreArchive'
    }),

    ...mapActions('tags', {
      getTagsList: 'getTagsList'
    }),

    bootstrap () {
      const config = {
        loading: 'dataStatus.archiveTable.loading'
      }

      this.statusWrapper(async () => {
        await this.getArchivesList({ ...this.$route.query })
      }, config)
    },

    handleClickRestoreArchive ({ item }) {
      const success = async () => {
        try {
          await this.restoreArchive({ id: item.id })
          await this.bootstrap()
          this.$alert({ type: 'success' })
        } catch (error) {
          const message = _get(error, 'response.data.message')
          this.$setAlert({ type: 'error', text: message })
          throw new Error(error)
        }
      }

      this.$prompt({ success })
    },

    handleClickModifyArchive ({ item }) {
      const modals = this.modals.modifyArchive
      const clone = JSON.parse(JSON.stringify(item))

      modals.data.id = clone.id
      modals.data.title = clone.title
      modals.data.published_date = clone.published_date
      modals.data.adviser = clone.adviser
      modals.data.panelists = clone.panelists
      modals.data.tags = clone.tags
      modals.data.authors = clone.authors
      modals.data.note = null
      modals.data.file = null

      modals.status = true
    },

    async handleTriggerModifyArchive () {
      const modal = this.modals.modifyArchive

      const formData = new FormData()
      formData.append('id', modal.data.id)
      formData.append('title', modal.data.title)
      formData.append('published_date', modal.data.published_date)
      formData.append('adviser', modal.data.adviser)
      formData.append('note', modal.data.note)
      formData.append('file', modal.data.file)
      formData.append('panelists', JSON.stringify(modal.data.panelists.filter(Boolean)))
      formData.append('tags', JSON.stringify(modal.data.tags.filter(Boolean)))
      formData.append('authors', JSON.stringify(modal.data.authors.filter(Boolean)))

      try {
        await this.updateArchive(formData)
        await this.getArchivesList({ ...this.$route.query })
        this.$setAlert({ type: 'success' })
        this.modals.createArchive.status = false
        this.modals.createArchive.reset()
      } catch (error) {
        this.$handleError(error)
      }
    },

    async handleTriggerCreateArchive () {
      const modal = this.modals.createArchive

      const formData = new FormData()
      formData.append('title', modal.data.title)
      formData.append('published_date', modal.data.published_date)
      formData.append('adviser', modal.data.adviser)
      formData.append('note', modal.data.note)
      formData.append('file', modal.data.file)
      formData.append('panelists', JSON.stringify(modal.data.panelists.filter(Boolean)))
      formData.append('tags', JSON.stringify(modal.data.tags.filter(Boolean)))
      formData.append('authors', JSON.stringify(modal.data.authors.filter(Boolean)))

      console.log(modal.data.panelists)
      try {
        await this.postArchive(formData)
        await this.getArchivesList({ ...this.$route.query })
        this.$setAlert({ type: 'success' })
        modal.status = false
        modal.reset()
      } catch (error) {
        this.$handleError(error)
      }
    },

    handleClickDownloadFile ({ item, key }) {
      const uri = this.$toCDN(item[key || 'path'])

      this.$download(uri)
    },

    handleEnterTag ({ modal, e }) {
      this.modals[modal].data.tags.push(e.target.value)
      e.target.value = ''
    },

    handleClickDeleteArchive ({ item }) {
      const success = async () => {
        try {
          await this.deleteArchive({ id: item.id })
          await this.bootstrap()
          this.$alert({ type: 'success' })
        } catch (error) {
          const message = _get(error, 'response.data.message')
          this.$setAlert({ type: 'error', text: message })
          throw new Error(error)
        }
      }

      this.$prompt({ success })
    },

    handleClickCreatePanelistsKeyup ({ modal, e }) {
      const currModal = this.modals[modal]
      const value = e.target.value

      currModal.data.panelists.push(value)

      this.modals[modal].__ob__.dep.notify()

      e.target.value = ''
    },

    handleClickCreateRemovePanelist ({ key, modal }) {
      this.modals[modal].data.panelists.splice(key, 1)
      this.modals[modal].__ob__.dep.notify()
    },

    handleClickCreateAddAuthor ({ modal }) {
      const currModal = this.modals[modal]
      const author = currModal.data.author

      if (!author || !author.name || !author.year || !author.section) {
        return
      }

      currModal.data.authors.push({
        name: author.name,
        year: author.year,
        section: author.section
      })

      currModal.data.author.name = null
      currModal.data.author.year = null
      currModal.data.author.section = null
    }
  }
}
</script>
